pcl::Grabber Class Referenceabstract
Module io

Grabber interface for PCL 1.x device drivers. More...

`#include <pcl/io/grabber.h>`

Inheritance diagram for pcl::Grabber:

## Public Member Functions

| Grabber ()
| Constructor. More...
virtual | ~Grabber () throw ()
| virtual desctructor. More...
template<typename T >
boost::signals2::connection | registerCallback (const boost::function< T > &callback)
| registers a callback function/method to a signal with the corresponding signature More...
template<typename T >
bool | providesCallback () const
| indicates whether a signal with given parameter-type exists or not More...
virtual void | start ()=0
| For devices that are streaming, the streams are started by calling this method. More...
virtual void | stop ()=0
| For devices that are streaming, the streams are stopped. More...
virtual std::string | getName () const =0
| returns the name of the concrete subclass. More...
virtual bool | isRunning () const =0
| Indicates whether the grabber is streaming or not. More...
virtual float | getFramesPerSecond () const =0
| returns fps. More...

## Protected Member Functions

virtual void | signalsChanged ()
template<typename T >
boost::signals2::signal< T > * | find_signal () const
template<typename T >
int | num_slots () const
template<typename T >
void | disconnect_all_slots ()
template<typename T >
void | block_signal ()
template<typename T >
void | unblock_signal ()
void | block_signals ()
void | unblock_signals ()
template<typename T >
boost::signals2::signal< T > * | createSignal ()

## Protected Attributes

std::map< std::string, boost::signals2::signal_base * > | signals_
std::map< std::string, std::vector< boost::signals2::connection > > | connections_
std::map< std::string, std::vector< boost::signals2::shared_connection_block > > | shared_connections_

## Detailed Description

Grabber interface for PCL 1.x device drivers.

Author
  Suat Gedikli gedik.nosp@m.li@w.nosp@m.illow.nosp@m.gara.nosp@m.ge.co.nosp@m.m

Definition at line 58 of file grabber.h.

## Constructor & Destructor Documentation

pcl::Grabber::Grabber | ( |  | ) |

inline

Constructor.

Definition at line 63 of file grabber.h.

pcl::Grabber::~Grabber | ( |  | ) |
throw | ( |
| ) |  |

inline virtual

virtual desctructor.

Definition at line 143 of file grabber.h.

## Member Function Documentation

template<typename T >

void pcl::Grabber::block_signal | ( |  | ) |

protected

Definition at line 174 of file grabber.h.

void pcl::Grabber::block_signals | ( |  | ) |

inline protected

Definition at line 190 of file grabber.h.

template<typename T >

boost::signals2::signal< T > * pcl::Grabber::createSignal | ( |  | ) |

protected

Definition at line 221 of file grabber.h.

template<typename T >

void pcl::Grabber::disconnect_all_slots | ( |  | ) |

protected

Definition at line 162 of file grabber.h.

template<typename T >

boost::signals2::signal< T > * pcl::Grabber::find_signal | ( |  | ) | const

protected

Definition at line 150 of file grabber.h.

virtual float pcl::Grabber::getFramesPerSecond | ( |  | ) | const

pure virtual

returns fps.

0 if trigger based.

Implemented in pcl::HDLGrabber, pcl::OpenNIGrabber, pcl::PCDGrabberBase, pcl::ImageGrabberBase, pcl::ONIGrabber, pcl::PXCGrabber, pcl::DinastGrabber, and pcl::RobotEyeGrabber.

virtual std::string pcl::Grabber::getName | ( |  | ) | const

pure virtual

returns the name of the concrete subclass.

Returns
  the name of the concrete driver.

Implemented in pcl::HDLGrabber, pcl::OpenNIGrabber, pcl::PCDGrabberBase, pcl::ImageGrabberBase, pcl::PXCGrabber, pcl::ONIGrabber, pcl::RobotEyeGrabber, and pcl::DinastGrabber.

virtual bool pcl::Grabber::isRunning | ( |  | ) | const

pure virtual

Indicates whether the grabber is streaming or not.

This value is not defined for triggered devices.

Returns
  true if grabber is running / streaming. False otherwise.

Implemented in pcl::HDLGrabber, pcl::OpenNIGrabber, pcl::ONIGrabber, pcl::PCDGrabberBase, pcl::ImageGrabberBase, pcl::PXCGrabber, pcl::RobotEyeGrabber, and pcl::DinastGrabber.

template<typename T >

int pcl::Grabber::num_slots | ( |  | ) | const

protected

Definition at line 206 of file grabber.h.

template<typename T >

bool pcl::Grabber::providesCallback | ( |  | ) | const

indicates whether a signal with given parameter-type exists or not

Returns
  true if signal exists, false otherwise

Definition at line 264 of file grabber.h.

template<typename T >

boost::signals2::connection pcl::Grabber::registerCallback | ( | const boost::function< T > & | callback | ) |

registers a callback function/method to a signal with the corresponding signature

Parameters

  [in] | callback | the callback function/method

Returns
  Connection object, that can be used to disconnect the callback method from the signal again.

Definition at line 235 of file grabber.h.

virtual void pcl::Grabber::signalsChanged | ( |  | ) |

inline protected virtual

Reimplemented in pcl::OpenNIGrabber.

Definition at line 112 of file grabber.h.

virtual void pcl::Grabber::start | ( |  | ) |

pure virtual

For devices that are streaming, the streams are started by calling this method.

Trigger-based devices, just trigger the device once for each call of start.

Implemented in pcl::HDLGrabber, pcl::OpenNIGrabber, pcl::PXCGrabber, pcl::PCDGrabberBase, pcl::ONIGrabber, pcl::ImageGrabberBase, pcl::DinastGrabber, and pcl::RobotEyeGrabber.

virtual void pcl::Grabber::stop | ( |  | ) |

pure virtual

For devices that are streaming, the streams are stopped.

This method has no effect for triggered devices.

Implemented in pcl::HDLGrabber, pcl::OpenNIGrabber, pcl::ONIGrabber, pcl::PXCGrabber, pcl::PCDGrabberBase, pcl::ImageGrabberBase, pcl::DinastGrabber, and pcl::RobotEyeGrabber.

template<typename T >

void pcl::Grabber::unblock_signal | ( |  | ) |

protected

Definition at line 182 of file grabber.h.

void pcl::Grabber::unblock_signals | ( |  | ) |

inline protected

Definition at line 198 of file grabber.h.

## Member Data Documentation

std::map<std::string, std::vector<boost::signals2::connection> > pcl::Grabber::connections_

protected

Definition at line 139 of file grabber.h.

std::map<std::string, std::vector<boost::signals2::shared_connection_block> > pcl::Grabber::shared_connections_

protected

Definition at line 140 of file grabber.h.

std::map<std::string, boost::signals2::signal_base*> pcl::Grabber::signals_

protected

Definition at line 138 of file grabber.h.

The documentation for this class was generated from the following file:

- /build/pcl-0nnAvv/pcl-1.7.2/io/include/pcl/io/grabber.h